## foonathan-memory 0.7

=== CMakeLists.txt ===
# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
# This file is subject to the license terms in the LICENSE file
# found in the top-level directory of this distribution.

# root CMakeLists.txt, specifies option and interface library

cmake_minimum_required(VERSION 3.1)
project(FOONATHAN_MEMORY)

set(FOONATHAN_MEMORY_VERSION_MAJOR 0 CACHE STRING "major version of memory" FORCE)
set(FOONATHAN_MEMORY_VERSION_MINOR 7 CACHE STRING "minor version of memory" FORCE)
set(FOONATHAN_MEMORY_VERSION_PATCH 0 CACHE STRING "patch version of memory" FORCE)
set(FOONATHAN_MEMORY_VERSION "${FOONATHAN_MEMORY_VERSION_MAJOR}.${FOONATHAN_MEMORY_VERSION_MINOR}.${FOONATHAN_MEMORY_VERSION_PATCH}"
                             CACHE STRING "version of memory" FORCE)


# set a debug postfix
set(CMAKE_DEBUG_POSTFIX "-dbg")

# installation destinations
if(UNIX OR VXWORKS)
    include(GNUInstallDirs)

    set(FOONATHAN_MEMORY_INC_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/foonathan_memory")
    set(FOONATHAN_MEMORY_RUNTIME_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}")
    set(FOONATHAN_MEMORY_LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")
    set(FOONATHAN_MEMORY_ARCHIVE_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")
    set(FOONATHAN_MEMORY_FRAMEWORK_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}")

    set(FOONATHAN_MEMORY_CMAKE_CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/foonathan_memory/cmake")
    set(FOONATHAN_MEMORY_ADDITIONAL_FILES_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/foonathan_memory")
elseif(WIN32)
    set(FOONATHAN_MEMORY_INC_INSTALL_DIR "include/foonathan_memory")
    set(FOONATHAN_MEMORY_RUNTIME_INSTALL_DIR   "bin")
    set(FOONATHAN_MEMORY_LIBRARY_INSTALL_DIR   "bin")
    set(FOONATHAN_MEMORY_ARCHIVE_INSTALL_DIR   "lib")
    set(FOONATHAN_MEMORY_FRAMEWORK_INSTALL_DIR "bin")

    set(FOONATHAN_MEMORY_CMAKE_CONFIG_INSTALL_DIR "share/foonathan_memory/cmake")
    set(FOONATHAN_MEMORY_ADDITIONAL_FILES_INSTALL_DIR "share/foonathan_memory")
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
else()
    message(FATAL_ERROR "Could not set install folders for this platform!")
endif()

include(cmake/configuration.cmake)

# subdirectories
add_subdirectory(src)
if(FOONATHAN_MEMORY_BUILD_EXAMPLES)
    add_subdirectory(example)
endif()
if(FOONATHAN_MEMORY_BUILD_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()
if(FOONATHAN_MEMORY_BUILD_TOOLS)
    add_subdirectory(tool)
endif()

# install readme and license
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE" "${CMAKE_CURRENT_SOURCE_DIR}/README.md" DESTINATION ${FOONATHAN_MEMORY_ADDITIONAL_FILES_INSTALL_DIR})

install(EXPORT foonathan_memoryTargets DESTINATION ${FOONATHAN_MEMORY_CMAKE_CONFIG_INSTALL_DIR}
                                       FILE foonathan_memory-config.cmake)

=== example/CMakeLists.txt ===
# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
# This file is subject to the license terms in the LICENSE file
# found in the top-level directory of this distribution.

# builds examples

macro(_foonathan_add_example name)
    add_executable(foonathan_memory_example_${name} ${name}.cpp)
    target_link_libraries(foonathan_memory_example_${name} PRIVATE foonathan_memory)
endmacro()

_foonathan_add_example(allocator_storage)
_foonathan_add_example(joint_allocation)
_foonathan_add_example(taking_allocators)

if(NOT FOONATHAN_MEMORY_NO_NODE_SIZE)
_foonathan_add_example(tracking)
_foonathan_add_example(using_allocators)
endif()

=== src/CMakeLists.txt ===
# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
# This file is subject to the license terms in the LICENSE file
# found in the top-level directory of this distribution.

# builds actual library

set(header_path ${FOONATHAN_MEMORY_SOURCE_DIR}/include/foonathan/memory)
set(detail_header
        ${header_path}/detail/align.hpp
        ${header_path}/detail/assert.hpp
        ${header_path}/detail/container_node_sizes.hpp
        ${header_path}/detail/debug_helpers.hpp
        ${header_path}/detail/ebo_storage.hpp
        ${header_path}/detail/free_list.hpp
        ${header_path}/detail/free_list_array.hpp
        ${header_path}/detail/ilog2.hpp
        ${header_path}/detail/lowlevel_allocator.hpp
        ${header_path}/detail/memory_stack.hpp
        ${header_path}/detail/small_free_list.hpp
        ${header_path}/detail/utility.hpp)
set(header
        ${header_path}/aligned_allocator.hpp
        ${header_path}/allocator_storage.hpp
        ${header_path}/allocator_traits.hpp
        ${header_path}/config.hpp
        ${header_path}/container.hpp
        ${header_path}/debugging.hpp
        ${header_path}/default_allocator.hpp
        ${header_path}/deleter.hpp
        ${header_path}/error.hpp
        ${header_path}/fallback_allocator.hpp
        ${header_path}/malloc_allocator.hpp
        ${header_path}/heap_allocator.hpp
        ${header_path}/iteration_allocator.hpp
        ${header_path}/joint_allocator.hpp
        ${header_path}/memory_arena.hpp
        ${header_path}/memory_pool.hpp
        ${header_path}/memory_pool_collection.hpp
        ${header_path}/memory_pool_type.hpp
        ${header_path}/memory_resource_adapter.hpp
        ${header_path}/memory_stack.hpp
        ${header_path}/namespace_alias.hpp
        ${header_path}/new_allocator.hpp
        ${header_path}/segregator.hpp
        ${header_path}/smart_ptr.hpp
        ${header_path}/static_allocator.hpp
        ${header_path}/std_allocator.hpp
        ${header_path}/temporary_allocator.hpp
        ${header_path}/threading.hpp
        ${header_path}/tracking.hpp
        ${header_path}/virtual_memory.hpp
        ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp)

set(src
        detail/align.cpp
        detail/debug_helpers.cpp
        detail/assert.cpp
        detail/free_list.cpp
        detail/free_list_array.cpp
        detail/free_list_utils.hpp
        detail/small_free_list.cpp
        debugging.cpp
        error.cpp
        heap_allocator.cpp
        iteration_allocator.cpp
        malloc_allocator.cpp
        memory_arena.cpp
        memory_pool.cpp
        memory_pool_collection.cpp
        memory_stack.cpp
        new_allocator.cpp
        static_allocator.cpp
        temporary_allocator.cpp
        virtual_memory.cpp)

# configure config file
configure_file("config.hpp.in" "${CMAKE_CURRENT_BINARY_DIR}/config_impl.hpp")

# generate container_node_sizes.hpp
# don't run it while cross-compiling and CMAKE_CROSSCOMPILING_EMULATOR is not defined
if(FOONATHAN_MEMORY_BUILD_TOOLS)
  if(NOT CMAKE_CROSSCOMPILING)
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
            COMMAND $<TARGET_FILE:foonathan_memory_node_size_debugger> --code ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
            DEPENDS foonathan_memory_node_size_debugger
            VERBATIM)
  elseif(DEFINED CMAKE_CROSSCOMPILING_EMULATOR)
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:foonathan_memory_node_size_debugger> --code ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
            DEPENDS foonathan_memory_node_size_debugger
            VERBATIM)
  elseif(QNX OR QNXNTO)
    if(EXISTS "${FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL}")
      message("-- Using the pre-generated file: ${FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL}")
      add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
            COMMAND cp ${FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL} ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp )
    else()
      message(FATAL_ERROR "\nError: Cannot find pre-generated file container_node_sizes_impl.hpp\n"
                            "Please pre-generate the header file container_node_sizes_impl.hpp by following the steps below:\n"
                            "- Build nodesize_dbg from source:\n"
                            "	${PROJECT_SOURCE_DIR}/tool/node_size_debugger.cpp \n"
                            "- Transfer nodesize_dbg to QNX target and execute:\n"
                            "	nodesize_dbg --code container_node_sizes_impl.hpp \n"
                            "- Transfer generated header file back to your development system \n" 
                            "- Set FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL to the path of the pre-generated file and pass it to cmake as an argument\n")
    endif()
  else()
    message(WARNING "cross-compiling, but emulator is not defined, "
                    "cannot generate container_node_sizes_impl.hpp, node size information will be unavailable")
    file(WRITE  ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp "#define FOONATHAN_MEMORY_NO_NODE_SIZE")
    set(FOONATHAN_MEMORY_NO_NODE_SIZE 1 PARENT_SCOPE)
  endif()
else()
    message(WARNING "cannot generate container_node_sizes_impl.hpp, node size information will be unavailable")
    file(WRITE  ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp "#define FOONATHAN_MEMORY_NO_NODE_SIZE")
    set(FOONATHAN_MEMORY_NO_NODE_SIZE 1 PARENT_SCOPE)
endif()

add_library(foonathan_memory ${detail_header} ${header} ${src})
target_include_directories(foonathan_memory PUBLIC $<BUILD_INTERFACE:${FOONATHAN_MEMORY_SOURCE_DIR}/include/> # for client in subdirectory
                                                   $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> # for generated files in build mode
                                                   $<INSTALL_INTERFACE:${FOONATHAN_MEMORY_INC_INSTALL_DIR}> # for client in install mode
                                            PRIVATE ${header_path}) # for source files
target_compile_definitions(foonathan_memory PUBLIC
                            FOONATHAN_MEMORY=1
                            FOONATHAN_MEMORY_VERSION_MAJOR=${FOONATHAN_MEMORY_VERSION_MAJOR}
                            FOONATHAN_MEMORY_VERSION_MINOR=${FOONATHAN_MEMORY_VERSION_MINOR}
                            FOONATHAN_MEMORY_VERSION_PATCH=${FOONATHAN_MEMORY_VERSION_PATCH})
if(NOT MSVC)
target_compile_features(foonathan_memory PUBLIC cxx_constexpr)
endif()

set_target_properties(foonathan_memory PROPERTIES
                                       OUTPUT_NAME "foonathan_memory-${FOONATHAN_MEMORY_VERSION}"
                                       POSITION_INDEPENDENT_CODE ON)

install(TARGETS foonathan_memory EXPORT foonathan_memoryTargets
        RUNTIME       DESTINATION ${FOONATHAN_MEMORY_RUNTIME_INSTALL_DIR}
        LIBRARY       DESTINATION ${FOONATHAN_MEMORY_LIBRARY_INSTALL_DIR}
        ARCHIVE       DESTINATION ${FOONATHAN_MEMORY_ARCHIVE_INSTALL_DIR}
        FRAMEWORK     DESTINATION ${FOONATHAN_MEMORY_FRAMEWORK_INSTALL_DIR})

# Write/install version file
include(CMakePackageConfigHelpers)
set(version_file "${CMAKE_CURRENT_BINARY_DIR}/cmake/foonathan_memory-config-version.cmake")
write_basic_package_version_file(${version_file}
                                 VERSION ${FOONATHAN_MEMORY_VERSION}
                                 COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config_impl.hpp DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR}/foonathan/memory/detail)
install(FILES ${header}                                   DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR}/foonathan/memory)
install(FILES ${detail_header}                            DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR}/foonathan/memory/detail)
install(FILES ${version_file}                             DESTINATION ${FOONATHAN_MEMORY_CMAKE_CONFIG_INSTALL_DIR})

=== test/CMakeLists.txt ===
# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
# This file is subject to the license terms in the LICENSE file
# found in the top-level directory of this distribution.

# builds test

add_executable(foonathan_memory_profiling benchmark.hpp profiling.cpp)
target_link_libraries(foonathan_memory_profiling foonathan_memory)
target_include_directories(foonathan_memory_profiling PRIVATE
                            ${FOONATHAN_MEMORY_SOURCE_DIR}/include/foonathan/memory)

if(NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/catch.hpp)
    file(DOWNLOAD
         https://raw.githubusercontent.com/catchorg/Catch2/2e61d38c7c3078e600c331257b5bebfb81aaa685/single_include/catch2/catch.hpp
         ${CMAKE_CURRENT_BINARY_DIR}/catch.hpp
         STATUS status
         LOG log)

    list(GET status 0 status_code)
    list(GET status 1 status_string)

    if(NOT status_code EQUAL 0)
        message(FATAL_ERROR "error downloading catch: ${status_string}"
                            "${log}")
    endif()
endif()

set(tests
    test_allocator.hpp
    test.cpp
    detail/align.cpp
    detail/debug_helpers.cpp
    detail/free_list.cpp
    detail/free_list_array.cpp
    detail/ilog2.cpp
    detail/memory_stack.cpp
    aligned_allocator.cpp
    allocator_traits.cpp
    default_allocator.cpp
    fallback_allocator.cpp
    iteration_allocator.cpp
    joint_allocator.cpp
    memory_arena.cpp
    memory_pool.cpp
    memory_pool_collection.cpp
    memory_resource_adapter.cpp
    memory_stack.cpp
    segregator.cpp
    smart_ptr.cpp)

add_executable(foonathan_memory_test ${tests})
target_link_libraries(foonathan_memory_test foonathan_memory)
target_include_directories(foonathan_memory_test PRIVATE
                            ${CMAKE_CURRENT_BINARY_DIR}
                            ${FOONATHAN_MEMORY_SOURCE_DIR}/include/foonathan/memory)

add_test(NAME test COMMAND foonathan_memory_test)

=== tool/CMakeLists.txt ===
# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
# This file is subject to the license terms in the LICENSE file
# found in the top-level directory of this distribution.

# builds tools

add_executable(foonathan_memory_node_size_debugger test_types.hpp node_size_debugger.hpp node_size_debugger.cpp)
if (CMAKE_CROSSCOMPILING)
    # statically link when cross compiling so emulator doesn't need library paths
    if (MSVC)
        set_target_properties(foonathan_memory_node_size_debugger PROPERTIES LINK_FLAGS "/WHOLEARCHIVE")
    else()
        set_target_properties(foonathan_memory_node_size_debugger PROPERTIES LINK_FLAGS "-static")
    endif()
endif()
if (MSVC)
    target_compile_options(foonathan_memory_node_size_debugger PRIVATE "/bigobj")
endif()
target_compile_definitions(foonathan_memory_node_size_debugger PUBLIC
                           VERSION="${FOONATHAN_MEMORY_VERSION_MAJOR}.${FOONATHAN_MEMORY_VERSION_MINOR}")
set_target_properties(foonathan_memory_node_size_debugger PROPERTIES OUTPUT_NAME nodesize_dbg)
if(NOT MSVC)
target_compile_features(foonathan_memory_node_size_debugger PUBLIC cxx_constexpr)
endif()

install(TARGETS foonathan_memory_node_size_debugger EXPORT foonathan_memoryTargets
                                                    RUNTIME DESTINATION ${FOONATHAN_MEMORY_RUNTIME_INSTALL_DIR})

=== debian/changelog ===
foonathan-memory (0.7-3) unstable; urgency=medium

  * Mark lambda function symbols as optional
  * Add "Multi-Arch: foreign" to libfoonathan-memory-doc
  * Fix libatomic check (FTBFS on riscv64)

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 10 Dec 2020 10:20:47 +0100

foonathan-memory (0.7-2) unstable; urgency=medium

  * Detect correct container node size
  * Install arch-specific header to arch-specific location
  * Put version number into config_impl.hpp
  * Link against libatomic if needed

 -- Timo Röhling <timo@gaussglocke.de>  Mon, 07 Dec 2020 11:21:23 +0100

foonathan-memory (0.7-1) unstable; urgency=medium

  * Initial release (Closes: #975447)

 -- Timo Röhling <timo@gaussglocke.de>  Wed, 02 Dec 2020 19:58:37 +0100

=== debian/control ===
Source: foonathan-memory
Section: libs
Priority: optional
Maintainer: Timo Röhling <timo@gaussglocke.de>
Build-Depends: debhelper-compat (= 13),
               cmake, pkg-kde-tools,
               doxygen <!nodoc>, catch2 <!nocheck>
Standards-Version: 4.5.1
Homepage: https://github.com/foonathan/memory
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/foonathan-memory.git
Vcs-Browser: https://salsa.debian.org/roehling/foonathan-memory

Package: libfoonathan-memory0d
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: STL compatible C++ memory allocator library
 The default STL allocator model has various flaws, for example you cannot
 easily share a single allocator for multiple types. This library is one of
 many proposed solutions for the shortcomings of the standard allocator, which
 unlike many other solutions does not require changes in the STL itself.

Package: libfoonathan-memory-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfoonathan-memory0d (= ${binary:Version}), ${misc:Depends}
Description: STL compatible C++ memory allocator library - development headers
 The default STL allocator model has various flaws, for example you cannot
 easily share a single allocator for multiple types. This library is one of
 many proposed solutions for the shortcomings of the standard allocator, which
 unlike many other solutions does not require changes in the STL itself.
 .
 This package provides the development headers.

Package: libfoonathan-memory-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: STL compatible C++ memory allocator library - documentation
 The default STL allocator model has various flaws, for example you cannot
 easily share a single allocator for multiple types. This library is one of
 many proposed solutions for the shortcomings of the standard allocator, which
 unlike many other solutions does not require changes in the STL itself.
 .
 This package provides the API documentation.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility-inlines-hidden

include /usr/share/dpkg/architecture.mk

ENABLE_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@ --buildsystem=cmake --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_SHARED_LIBS=ON \
		-DHOST_TRIPLET=$(DEB_HOST_MULTIARCH) \
		-DFOONATHAN_MEMORY_BUILD_TESTS=$(ENABLE_TESTING) \
		-DFOONATHAN_MEMORY_BUILD_EXAMPLES=OFF \
		-DFOONATHAN_MEMORY_BUILD_TOOLS=ON \
		-DFOONATHAN_MEMORY_SOVERSION=0d

execute_after_dh_auto_build-indep:
	[ -n "$(filter nodoc,$(DEB_BUILD_OPTIONS))" ] || doxygen doc/Doxyfile

execute_after_dh_auto_install:
	rm debian/tmp/usr/share/foonathan_memory/LICENSE \
	   debian/tmp/usr/share/foonathan_memory/README.md \
	   debian/tmp/usr/bin/nodesize_dbg

execute_after_dh_installdocs-indep:
	[ -n "$(filter nodoc,$(DEB_BUILD_OPTIONS))" ] || dh_doxygen

=== debian/tests/control ===
Tests: build-and-run-test-suite
Depends: libfoonathan-memory-dev, cmake, catch2, g++
Restrictions: allow-stderr

## foonathan-memory 0.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,15 @@
-# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
+# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
 # This file is subject to the license terms in the LICENSE file
 # found in the top-level directory of this distribution.
 
 # root CMakeLists.txt, specifies option and interface library
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.11)
 project(FOONATHAN_MEMORY)
 
 set(FOONATHAN_MEMORY_VERSION_MAJOR 0 CACHE STRING "major version of memory" FORCE)
 set(FOONATHAN_MEMORY_VERSION_MINOR 7 CACHE STRING "minor version of memory" FORCE)
-set(FOONATHAN_MEMORY_VERSION_PATCH 0 CACHE STRING "patch version of memory" FORCE)
+set(FOONATHAN_MEMORY_VERSION_PATCH 1 CACHE STRING "patch version of memory" FORCE)
 set(FOONATHAN_MEMORY_VERSION "${FOONATHAN_MEMORY_VERSION_MAJOR}.${FOONATHAN_MEMORY_VERSION_MINOR}.${FOONATHAN_MEMORY_VERSION_PATCH}"
                              CACHE STRING "version of memory" FORCE)
 
@@ -44,6 +44,7 @@
 endif()
 
 include(cmake/configuration.cmake)
+include(cmake/atomic.cmake)
 
 # subdirectories
 add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
+# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
 # This file is subject to the license terms in the LICENSE file
 # found in the top-level directory of this distribution.
 
@@ -101,7 +101,7 @@
                             "	${PROJECT_SOURCE_DIR}/tool/node_size_debugger.cpp \n"
                             "- Transfer nodesize_dbg to QNX target and execute:\n"
                             "	nodesize_dbg --code container_node_sizes_impl.hpp \n"
-                            "- Transfer generated header file back to your development system \n" 
+                            "- Transfer generated header file back to your development system \n"
                             "- Set FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL to the path of the pre-generated file and pass it to cmake as an argument\n")
     endif()
   else()
@@ -130,9 +130,25 @@
 target_compile_features(foonathan_memory PUBLIC cxx_constexpr)
 endif()
 
+if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
+    if("${CMAKE_CXX_SIMULATE_ID}" STREQUAL "MSVC")
+        target_compile_options(foonathan_memory PRIVATE /WX /W3 /D _CRT_SECURE_NO_WARNINGS)
+    else()
+        target_compile_options(foonathan_memory PRIVATE -pedantic-errors -Werror -Wall -Wextra -Wconversion -Wsign-conversion)
+    endif()
+elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
+    target_compile_options(foonathan_memory PRIVATE -pedantic-errors -Werror -Wall -Wextra -Wconversion -Wsign-conversion)
+elseif(MSVC)
+    target_compile_options(foonathan_memory PRIVATE /WX /W3 /D _CRT_SECURE_NO_WARNINGS)
+endif()
+
 set_target_properties(foonathan_memory PROPERTIES
                                        OUTPUT_NAME "foonathan_memory-${FOONATHAN_MEMORY_VERSION}"
                                        POSITION_INDEPENDENT_CODE ON)
+
+if(NEED_LIBRARY_FOR_CXX_ATOMIC)
+    target_link_libraries(foonathan_memory PRIVATE -latomic)
+endif()
 
 install(TARGETS foonathan_memory EXPORT foonathan_memoryTargets
         RUNTIME       DESTINATION ${FOONATHAN_MEMORY_RUNTIME_INSTALL_DIR}
@@ -147,7 +163,7 @@
                                  VERSION ${FOONATHAN_MEMORY_VERSION}
                                  COMPATIBILITY AnyNewerVersion)
 
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config_impl.hpp DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR})
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config_impl.hpp DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR}/foonathan/memory/)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR}/foonathan/memory/detail)
 install(FILES ${header}                                   DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR}/foonathan/memory)
 install(FILES ${detail_header}                            DESTINATION ${FOONATHAN_MEMORY_INC_INSTALL_DIR}/foonathan/memory/detail)

=== test/CMakeLists.txt ===
# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
# This file is subject to the license terms in the LICENSE file
# found in the top-level directory of this distribution.

# builds test

add_executable(foonathan_memory_profiling benchmark.hpp profiling.cpp)
target_link_libraries(foonathan_memory_profiling foonathan_memory)
target_include_directories(foonathan_memory_profiling PRIVATE
                            ${FOONATHAN_MEMORY_SOURCE_DIR}/include/foonathan/memory)

# Fetch doctest.
message(STATUS "Fetching doctest")
include(FetchContent)
FetchContent_Declare(doctest URL https://github.com/onqtam/doctest/archive/2.4.5.zip)
FetchContent_MakeAvailable(doctest)

set(tests
    test_allocator.hpp
    test.cpp
    detail/align.cpp
    detail/debug_helpers.cpp
    detail/free_list.cpp
    detail/free_list_array.cpp
    detail/ilog2.cpp
    detail/memory_stack.cpp
    aligned_allocator.cpp
    allocator_traits.cpp
    default_allocator.cpp
    fallback_allocator.cpp
    iteration_allocator.cpp
    joint_allocator.cpp
    memory_arena.cpp
    memory_pool.cpp
    memory_pool_collection.cpp
    memory_resource_adapter.cpp
    memory_stack.cpp
    segregator.cpp
    smart_ptr.cpp)

add_executable(foonathan_memory_test ${tests})
target_link_libraries(foonathan_memory_test PRIVATE foonathan_memory doctest::doctest)
target_include_directories(foonathan_memory_test PRIVATE
                            ${FOONATHAN_MEMORY_SOURCE_DIR}/include/foonathan/memory)

add_test(NAME test COMMAND foonathan_memory_test)

=== debian/changelog ===
foonathan-memory (0.7.1-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields:
    Bug-Submit, Repository, Repository-Browse.

  [ Timo Röhling ]
  * Make package cross-compilable

 -- Timo Röhling <roehling@debian.org>  Tue, 12 Oct 2021 14:37:06 +0200

foonathan-memory (0.7.1-3) unstable; urgency=medium

  * Simplify d/rules
  * Transfer package to new Debian Robotics Team

 -- Timo Röhling <roehling@debian.org>  Sat, 09 Oct 2021 13:25:07 +0200

foonathan-memory (0.7.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Tue, 21 Sep 2021 13:13:44 +0200

foonathan-memory (0.7.1-1) experimental; urgency=medium

  * New upstream version 0.7.1
  * Bump Standards-Version to 4.6.0 (no changes)
  * Drop .symbols file
  * Bump SOVERSION

 -- Timo Röhling <roehling@debian.org>  Sat, 11 Sep 2021 01:35:56 +0200

foonathan-memory (0.7-4) unstable; urgency=medium

  * Handle vanished symbols with GCC-11 (Closes: #984133)
  * Update maintainer email address

 -- Timo Röhling <roehling@debian.org>  Sun, 15 Aug 2021 22:14:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,19 @@
 Source: foonathan-memory
 Section: libs
 Priority: optional
-Maintainer: Timo Röhling <timo@gaussglocke.de>
+Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
+Uploaders: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               cmake, pkg-kde-tools,
-               doxygen <!nodoc>, catch2 <!nocheck>
-Standards-Version: 4.5.1
+               cmake,
+               doxygen <!nodoc>, doctest-dev <!nocheck>,
+               qemu-user-static <cross>,
+Standards-Version: 4.6.0
 Homepage: https://github.com/foonathan/memory
 Rules-Requires-Root: no
-Vcs-Git: https://salsa.debian.org/roehling/foonathan-memory.git
-Vcs-Browser: https://salsa.debian.org/roehling/foonathan-memory
+Vcs-Git: https://salsa.debian.org/robotics-team/foonathan-memory.git
+Vcs-Browser: https://salsa.debian.org/robotics-team/foonathan-memory
 
-Package: libfoonathan-memory0d
+Package: libfoonathan-memory0.7.1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -25,7 +27,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libfoonathan-memory0d (= ${binary:Version}), ${misc:Depends}
+Depends: libfoonathan-memory0.7.1 (= ${binary:Version}), ${misc:Depends}
 Description: STL compatible C++ memory allocator library - development headers
  The default STL allocator model has various flaws, for example you cannot
  easily share a single allocator for multiple types. This library is one of

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility-inlines-hidden

include /usr/share/dpkg/architecture.mk

ENABLE_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

# Unfortunately, foonathan-memory needs to run a host binary to determine
# the (otherwise not accessible) sizes of the internal allocations for
# various STL containers. This is not particularly elegant, but it works.
ifneq ($(filter cross,$(DEB_BUILD_PROFILES)),)
QEMU_ARCH = $(DEB_HOST_ARCH)
ifneq ($(filter armhf armel,$(DEB_HOST_ARCH)),)
QEMU_ARCH = arm
endif
ifneq ($(filter ppc64el,$(DEB_HOST_ARCH)),)
QEMU_ARCH = ppc64le
endif
ifneq ($(filter powerpc,$(DEB_HOST_ARCH)),)
QEMU_ARCH = ppc
endif
ifneq ($(filter arm64,$(DEB_HOST_ARCH)),)
QEMU_ARCH = aarch64
endif
ifneq ($(filter amd64,$(DEB_HOST_ARCH)),)
QEMU_ARCH = x86_64
endif
ifneq ($(shell command -v qemu-$(QEMU_ARCH)-static),)
CROSSCOMPILING_EMULATOR = -DCMAKE_CROSSCOMPILING_EMULATOR=qemu-$(QEMU_ARCH)-static
endif
endif

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		$(CROSSCOMPILING_EMULATOR) \
		-DBUILD_SHARED_LIBS=ON \
		-DHOST_TRIPLET=$(DEB_HOST_MULTIARCH) \
		-DFOONATHAN_MEMORY_BUILD_TESTS=$(ENABLE_TESTING) \
		-DFOONATHAN_MEMORY_BUILD_EXAMPLES=OFF \
		-DFOONATHAN_MEMORY_BUILD_TOOLS=ON

execute_after_dh_auto_build-indep:
ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS)),)
	doxygen doc/Doxyfile
endif

execute_after_dh_auto_install:
	rm debian/tmp/usr/share/foonathan_memory/LICENSE \
	   debian/tmp/usr/share/foonathan_memory/README.md \
	   debian/tmp/usr/bin/nodesize_dbg

execute_after_dh_installdocs-indep:
ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS)),)
	dh_doxygen
endif

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/foonathan-memory-$1\.tar\.gz/,\
uversionmangle=s/-/./ \
  https://github.com/foonathan/memory/releases .*/v?(\d\S+)\.tar\.gz

## foonathan-memory 0.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 set(FOONATHAN_MEMORY_VERSION_MAJOR 0 CACHE STRING "major version of memory" FORCE)
 set(FOONATHAN_MEMORY_VERSION_MINOR 7 CACHE STRING "minor version of memory" FORCE)
-set(FOONATHAN_MEMORY_VERSION_PATCH 1 CACHE STRING "patch version of memory" FORCE)
+set(FOONATHAN_MEMORY_VERSION_PATCH 2 CACHE STRING "patch version of memory" FORCE)
 set(FOONATHAN_MEMORY_VERSION "${FOONATHAN_MEMORY_VERSION_MAJOR}.${FOONATHAN_MEMORY_VERSION_MINOR}.${FOONATHAN_MEMORY_VERSION_PATCH}"
                              CACHE STRING "version of memory" FORCE)
 
@@ -39,12 +39,14 @@
     set(FOONATHAN_MEMORY_CMAKE_CONFIG_INSTALL_DIR "share/foonathan_memory/cmake")
     set(FOONATHAN_MEMORY_ADDITIONAL_FILES_INSTALL_DIR "share/foonathan_memory")
     set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
+    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
 else()
     message(FATAL_ERROR "Could not set install folders for this platform!")
 endif()
 
 include(cmake/configuration.cmake)
 include(cmake/atomic.cmake)
+include(cmake/get_container_node_sizes.cmake)
 
 # subdirectories
 add_subdirectory(src)

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
+# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
 # This file is subject to the license terms in the LICENSE file
 # found in the top-level directory of this distribution.

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -77,44 +77,7 @@
 configure_file("config.hpp.in" "${CMAKE_CURRENT_BINARY_DIR}/config_impl.hpp")
 
 # generate container_node_sizes.hpp
-# don't run it while cross-compiling and CMAKE_CROSSCOMPILING_EMULATOR is not defined
-if(FOONATHAN_MEMORY_BUILD_TOOLS)
-  if(NOT CMAKE_CROSSCOMPILING)
-    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
-            COMMAND $<TARGET_FILE:foonathan_memory_node_size_debugger> --code ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
-            DEPENDS foonathan_memory_node_size_debugger
-            VERBATIM)
-  elseif(DEFINED CMAKE_CROSSCOMPILING_EMULATOR)
-    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
-            COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:foonathan_memory_node_size_debugger> --code ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
-            DEPENDS foonathan_memory_node_size_debugger
-            VERBATIM)
-  elseif(QNX OR QNXNTO)
-    if(EXISTS "${FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL}")
-      message("-- Using the pre-generated file: ${FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL}")
-      add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp
-            COMMAND cp ${FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL} ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp )
-    else()
-      message(FATAL_ERROR "\nError: Cannot find pre-generated file container_node_sizes_impl.hpp\n"
-                            "Please pre-generate the header file container_node_sizes_impl.hpp by following the steps below:\n"
-                            "- Build nodesize_dbg from source:\n"
-                            "	${PROJECT_SOURCE_DIR}/tool/node_size_debugger.cpp \n"
-                            "- Transfer nodesize_dbg to QNX target and execute:\n"
-                            "	nodesize_dbg --code container_node_sizes_impl.hpp \n"
-                            "- Transfer generated header file back to your development system \n"
-                            "- Set FOONATHAN_MEMORY_CONTAINER_NODE_SIZES_IMPL to the path of the pre-generated file and pass it to cmake as an argument\n")
-    endif()
-  else()
-    message(WARNING "cross-compiling, but emulator is not defined, "
-                    "cannot generate container_node_sizes_impl.hpp, node size information will be unavailable")
-    file(WRITE  ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp "#define FOONATHAN_MEMORY_NO_NODE_SIZE")
-    set(FOONATHAN_MEMORY_NO_NODE_SIZE 1 PARENT_SCOPE)
-  endif()
-else()
-    message(WARNING "cannot generate container_node_sizes_impl.hpp, node size information will be unavailable")
-    file(WRITE  ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp "#define FOONATHAN_MEMORY_NO_NODE_SIZE")
-    set(FOONATHAN_MEMORY_NO_NODE_SIZE 1 PARENT_SCOPE)
-endif()
+get_container_node_sizes(${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp)
 
 add_library(foonathan_memory ${detail_header} ${header} ${src})
 target_include_directories(foonathan_memory PUBLIC $<BUILD_INTERFACE:${FOONATHAN_MEMORY_SOURCE_DIR}/include/> # for client in subdirectory

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # Fetch doctest.
 message(STATUS "Fetching doctest")
 include(FetchContent)
-FetchContent_Declare(doctest URL https://github.com/onqtam/doctest/archive/2.4.5.zip)
+FetchContent_Declare(doctest URL https://github.com/doctest/doctest/archive/refs/tags/v2.4.9.zip)
 FetchContent_MakeAvailable(doctest)
 
 set(tests

=== tool/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2015-2020 Jonathan Müller <jonathanmueller.dev@gmail.com>
+# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
 # This file is subject to the license terms in the LICENSE file
 # found in the top-level directory of this distribution.

=== debian/changelog ===
foonathan-memory (0.7.2-3) unstable; urgency=medium

  * Fix d/watch
  * Use AUTOPKGTEST_TMP

 -- Timo Röhling <roehling@debian.org>  Fri, 23 Dec 2022 14:12:17 +0100

foonathan-memory (0.7.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 07 Aug 2022 22:35:20 +0200

foonathan-memory (0.7.2-1) experimental; urgency=medium

  * New upstream version 0.7.2
  * Bump SONAME after ABI change
  * Bump Standards-Version to 4.6.1
  * Cross-compiling works without emulation now

 -- Timo Röhling <roehling@debian.org>  Thu, 04 Aug 2022 21:59:13 +0200

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,13 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                doxygen <!nodoc>, doctest-dev <!nocheck>,
-               qemu-user-static <cross>,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/foonathan/memory
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/robotics-team/foonathan-memory.git
 Vcs-Browser: https://salsa.debian.org/robotics-team/foonathan-memory
 
-Package: libfoonathan-memory0.7.1
+Package: libfoonathan-memory0.7.2
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -27,7 +26,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libfoonathan-memory0.7.1 (= ${binary:Version}), ${misc:Depends}
+Depends: libfoonathan-memory0.7.2 (= ${binary:Version}), ${misc:Depends}
 Description: STL compatible C++ memory allocator library - development headers
  The default STL allocator model has various flaws, for example you cannot
  easily share a single allocator for multiple types. This library is one of

## foonathan-memory 0.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,14 @@
-# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
-# This file is subject to the license terms in the LICENSE file
-# found in the top-level directory of this distribution.
+# Copyright (C) 2015-2023 Jonathan Müller and foonathan/memory contributors
+# SPDX-License-Identifier: Zlib
 
 # root CMakeLists.txt, specifies option and interface library
 
-cmake_minimum_required(VERSION 3.11)
+cmake_minimum_required(VERSION 3.14)
 project(FOONATHAN_MEMORY)
 
 set(FOONATHAN_MEMORY_VERSION_MAJOR 0 CACHE STRING "major version of memory" FORCE)
 set(FOONATHAN_MEMORY_VERSION_MINOR 7 CACHE STRING "minor version of memory" FORCE)
-set(FOONATHAN_MEMORY_VERSION_PATCH 2 CACHE STRING "patch version of memory" FORCE)
+set(FOONATHAN_MEMORY_VERSION_PATCH 3 CACHE STRING "patch version of memory" FORCE)
 set(FOONATHAN_MEMORY_VERSION "${FOONATHAN_MEMORY_VERSION_MAJOR}.${FOONATHAN_MEMORY_VERSION_MINOR}.${FOONATHAN_MEMORY_VERSION_PATCH}"
                              CACHE STRING "version of memory" FORCE)

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
-# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
-# This file is subject to the license terms in the LICENSE file
-# found in the top-level directory of this distribution.
+# Copyright (C) 2015-2023 Jonathan Müller and foonathan/memory contributors
+# SPDX-License-Identifier: Zlib
 
 # builds examples

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
-# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
-# This file is subject to the license terms in the LICENSE file
-# found in the top-level directory of this distribution.
+# Copyright (C) 2015-2023 Jonathan Müller and foonathan/memory contributors
+# SPDX-License-Identifier: Zlib
 
 # builds actual library
 
@@ -76,8 +75,10 @@
 # configure config file
 configure_file("config.hpp.in" "${CMAKE_CURRENT_BINARY_DIR}/config_impl.hpp")
 
-# generate container_node_sizes.hpp
-get_container_node_sizes(${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp)
+# generate container_node_sizes.hpp if necessary
+if(NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp)
+    get_container_node_sizes(${CMAKE_CURRENT_BINARY_DIR}/container_node_sizes_impl.hpp)
+endif()
 
 add_library(foonathan_memory ${detail_header} ${header} ${src})
 target_include_directories(foonathan_memory PUBLIC $<BUILD_INTERFACE:${FOONATHAN_MEMORY_SOURCE_DIR}/include/> # for client in subdirectory

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
-# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
-# This file is subject to the license terms in the LICENSE file
-# found in the top-level directory of this distribution.
+# Copyright (C) 2015-2023 Jonathan Müller and foonathan/memory contributors
+# SPDX-License-Identifier: Zlib
 
 # builds test

=== tool/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
-# Copyright (C) 2015-2021 Müller <jonathanmueller.dev@gmail.com>
-# This file is subject to the license terms in the LICENSE file
-# found in the top-level directory of this distribution.
+# Copyright (C) 2015-2023 Jonathan Müller and foonathan/memory contributors
+# SPDX-License-Identifier: Zlib
 
 # builds tools

=== debian/changelog ===
foonathan-memory (0.7.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061942

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:06:07 +0000

foonathan-memory (0.7.3-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Jun 2023 00:40:05 +0200

foonathan-memory (0.7.3-1) experimental; urgency=medium

  * New upstream version 0.7.3
  * Bump SONAME to 0.7.3
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Sun, 18 Jun 2023 21:22:26 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,19 @@
 Priority: optional
 Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
 Uploaders: Timo Röhling <roehling@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                cmake,
                doxygen <!nodoc>, doctest-dev <!nocheck>,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/foonathan/memory
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/robotics-team/foonathan-memory.git
 Vcs-Browser: https://salsa.debian.org/robotics-team/foonathan-memory
 
-Package: libfoonathan-memory0.7.2
+Package: libfoonathan-memory0.7.3t64
+Provides: ${t64:Provides}
+Replaces: libfoonathan-memory0.7.3
+Breaks: libfoonathan-memory0.7.3 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -26,7 +29,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libfoonathan-memory0.7.2 (= ${binary:Version}), ${misc:Depends}
+Depends: libfoonathan-memory0.7.3t64 (= ${binary:Version}), ${misc:Depends}
 Description: STL compatible C++ memory allocator library - development headers
  The default STL allocator model has various flaws, for example you cannot
  easily share a single allocator for multiple types. This library is one of

=== debian/tests/control ===
Tests: build-and-run-test-suite
Depends: libfoonathan-memory-dev, cmake, doctest-dev, g++
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 uversionmangle=s/-/./ \
 https://api.github.com/repos/foonathan/memory/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@
